
'Libreria di funzioni per la gestione
'dei files di testo.
' Cenati Giovanni
'http://digilander.libero.it/Cenati
'Codice liberamente utilizzabile citando il sito

'========================================================================
' Crea un file. Nel caso in cui gia' esiste, lo sovrascrive
'========================================================================
Sub File_Create( sFileName )
  Dim opfs, fp
  On Error Resume Next
	File_Create=True
	Set opfs = CreateObject("Scripting.FileSystemObject")
  if Err <> 0 then
		File_Create=False
		Exit Function
	end if
	Set fp = opfs.CreateTextFile( sFileName, True )
  if Err <> 0 then
	  set opfs = nothing
		File_Create=False
		Exit Function
	end if
  fp.Close
  set opfs = nothing
  Err.Clear
  On Error Goto 0
End Sub


'========================================================================
' Controlla se esiste il file passato come parametro.
' Ritorna TRUE nel caso in cui il file E' stato trovato.
'========================================================================
Function File_IsExist( sFileName )
Dim opfs
  On Error Resume Next
	File_IsExist=False
  Set opfs = CreateObject("Scripting.FileSystemObject")
  if Err <> 0 then
		Exit Function
	end if
  ' Test per l'esistenza del file
  File_IsExist = opfs.FileExists( sFileName )
  set opfs = nothing
  Err.Clear
  On Error Goto 0
End Function


'========================================================================
' Legge il contenuto del file 
' Ritorna il testo letto
'========================================================================
Function File_ReadEntireFile( sFileName )
  Const ForReading  = 1 'Apre un file in lettura.
  Dim opfs, fp, retstring
  On Error Resume Next
  File_ReadEntireFile = ""
  Set opfs = CreateObject("Scripting.FileSystemObject")
  if Err <> 0 then
		Exit Function
	end if
  Set fp = opfs.OpenTextFile( sFileName, ForReading, False )
  if Err <> 0 then
	  set opfs = nothing
		Exit Function
	end if
  Do While fp.AtEndOfStream <> True
    retstring = retstring + fp.ReadLine
  Loop
  fp.Close
  set opfs = nothing
  File_ReadEntireFile = retstring
  Err.Clear
  On Error Goto 0
End Function


'========================================================================
' Aggiunge al file sFileName una riga
'========================================================================
Function File_AppendLine( sFileName, sData )
  Const ForAppending= 8
  Dim opfs, fp, retstring
  On Error Resume Next
	File_AppendLine=False
  Set opfs = CreateObject("Scripting.FileSystemObject")
  if Err <> 0 then
		Exit Function
	end if
  Set fp = opfs.OpenTextFile( sFileName, ForAppending, False )
  if Err <> 0 then
	  set opfs = nothing
		Exit Function
	end if
  fp.WriteLine sData
  if Err <> 0 then
	  set opfs = nothing
		Exit Function
	end if
  fp.Close
	File_AppendLine=True
  set opfs = nothing
  Err.Clear
  On Error Goto 0
End Function


'========================================================================
' Crea il file sFileName ed aggiunge al file una riga
'========================================================================
Function File_WriteLine( sFileName, sData )
  Const ForWriting  = 2 'Apre un file in scrittura.
  Dim opfs, fp
  On Error Resume Next
	File_WriteLine=False
	Set opfs = CreateObject("Scripting.FileSystemObject")
  if Err <> 0 then
		Exit Function
	end if
	Set fp = opfs.OpenTextFile( sFileName, ForWriting, False )
  if Err <> 0 then
	  set opfs = nothing
		Exit Function
	end if
	fp.WriteLine sData
  if Err <> 0 then
	  set opfs = nothing
		Exit Function
	end if
	fp.Close
	File_WriteLine=True
	set opfs = nothing
  Err.Clear
  On Error Goto 0
End Function

'========================================================================
' Cancella il file sFileName
'========================================================================
Function File_Delete( sFileName )
  Dim opfs
  On Error Resume Next
	File_Delete = False
	Set opfs = CreateObject("Scripting.FileSystemObject")
  if Err <> 0 then Exit Function
	opfs.DeleteFile  sFileName, True 
  if Err <> 0 then Exit Function
	File_Delete = true
  set opfs = nothing
  Err.Clear
  On Error Goto 0
End Function

'========================================================================
' Cerca nel file sFileName l'occorrenza str e ritorna la riga
'========================================================================
Function FindInFileR( sFileName, str )
  Const ForReading  = 1 'Apre un file in lettura.
  Dim fso, fp
  Set fso = CreateObject("Scripting.FileSystemObject")
  Set fp = fso.OpenTextFile( sFileName, ForReading, False)
  FindInFileR = ""
  Do While fp.AtEndOfStream <> True
    strdata = fp.ReadLine
    if instr(strdata ,str ) then
      FindInFileR = strdata
      fp.Close
      exit function
    End If
  Loop
  fp.Close
End Function